package com.jpattern.orm.generator.reflection;

import java.lang.reflect.InvocationTargetException;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import com.jpattern.orm.generator.statement.PreparedStatementManipulator;

/**
 * 
 * @author Francesco Cina'
 *
 * Mar 31, 2012
 */
public class FieldManipulator {

	private final AGetFieldManipulator get;
	private final ASetFieldManipulator set;
	private final String columnName;
	private PreparedStatementManipulator<?> psManipulator;

	public FieldManipulator(final AGetFieldManipulator get, final ASetFieldManipulator set, final PreparedStatementManipulator<?> psManipulator , final String columnName) {
		this.get = get;
		this.set = set;
		this.psManipulator = psManipulator;
		this.columnName = columnName;
	}

	//Set the value of the field
	public void setValue(final Object bean, final Object value) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
		this.set.setValue(bean, value);
	}

	public void setValueFromResultSet(final Object bean, final ResultSet rs, final String rsColumnName) throws IllegalArgumentException, IllegalAccessException,	InvocationTargetException {
		this.set.setValueFromResultSet(bean, rs, rsColumnName);
	}

	public void setValueFromResultSet(final Object bean, final ResultSet rs, final int rsColumnIndex) throws IllegalArgumentException, IllegalAccessException,	InvocationTargetException {
		this.set.setValueFromResultSet(bean, rs, rsColumnIndex);
	}

	//get the value of the field
	public Object getValue(final Object bean) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
		return this.get.getValue(bean);
	}

	//The DB column name
	public String getColumnName() {
		return this.columnName;
	}

	public void setValueToPreparedStatement(final Object value, final PreparedStatement ps, final int index) throws SQLException {
		this.psManipulator.setValueToPreparedStatement(value, ps, index);
		//		ps.setObject(index, value);
	}

}
