package com.jpattern.orm.generator.reflection;

import com.jpattern.orm.classmapper.IClassMapper;
import com.jpattern.orm.generator.GeneratorStrategy;
import com.jpattern.orm.generator.IPersistorGenerator;
import com.jpattern.orm.generator.ResultSetMethodHelper;

/**
 * 
 * @author Francesco Cina'
 *
 * Mar 24, 2012
 */
public class ReflectionGeneratorStrategy implements GeneratorStrategy {

	@Override
	public <T> IPersistorGenerator<T> getGenerator(final IClassMapper<T> classMapper, final String classNameSuffix, final ResultSetMethodHelper resultSetMethodHelper) {
		return new ReflectionPersistorGenerator<T>(classMapper, resultSetMethodHelper);
	}

}
