package com.jpattern.orm.generator.wrapper;

import java.math.BigDecimal;

/**
 * 
 * @author Francesco Cina'
 *
 * Apr 1, 2012
 */
public class BooleanToBigDecimalWrapper implements TypeWrapper<Boolean, BigDecimal> {

	@Override
	public Class<BigDecimal> resultSetTypeToUse() {
		return BigDecimal.class;
	}

	@Override
	public Class<Boolean> wrapperClass() {
		return Boolean.class;
	}

	@Override
	public Boolean wrap(final BigDecimal value) {
		if (value==null) {
			return null;
		}
		return Boolean.valueOf( !BigDecimal.ZERO.equals(value) );
	}

	@Override
	public BigDecimal unWrap(final Boolean value) {
		if (value==null) {
			return null;
		}
		if (value) {
			return BigDecimal.ONE;
		}
		return BigDecimal.ZERO;
	}

}
