package com.jpattern.orm.generator.wrapper;

import java.math.BigDecimal;

/**
 * 
 * @author Francesco Cina'
 *
 * Apr 1, 2012
 */
public class FloatToBigDecimalWrapper implements TypeWrapper<Float, BigDecimal> {

	@Override
	public Class<BigDecimal> resultSetTypeToUse() {
		return BigDecimal.class;
	}

	@Override
	public Class<Float> wrapperClass() {
		return Float.class;
	}

	@Override
	public Float wrap(final BigDecimal value) {
		if (value==null) {
			return null;
		}
		return value.floatValue();
	}

	@Override
	public BigDecimal unWrap(final Float value) {
		if (value==null) {
			return null;
		}
		return BigDecimal.valueOf(value);
	}

}
